#include <stdio.h>
#include <stdlib.h>
#include <ncurses.h>
#include <signal.h>
#include <strings.h>
#include <unistd.h>
#include "init.h"
#include "globals.h"
#include "nInvaders.h"

char explosionchars[16]="@~`.,^#*-_=\\/%{}";

void game_over(int a) 
{
	int xo,yo;
	xo=(SCREENWIDTH/2)-(31/2);
	yo=(SCREENHEIGHT/2)-(13/2);
	copywin(gameoverbanner,battlefield,0,0,yo,xo,yo+12,xo+30,0);
	wrefresh(battlefield);
	sleep(4);

	finish(0);	
}

int hit_player_test(shotx,shoty,alienx,alieny)
{
	int getroffen=0;
	int shipx,shipy=0;
	if (shotx>=alienx && shotx<=alienx+30 && shoty>=alieny && shoty<=alieny+8) {
		shipx=(shotx-alienx)/3;
		shipy=(shoty-alieny)/2;
		if (enemy[shipy][shipx]!=0) {
			enemy[shipy][shipx]=0;	
			getroffen=1;
		}
	}
	return getroffen;
}

int hit_bunker_test(shotx,shoty)
{
	int adjx,adjy;
	if (shotx>=BUNKERX && shotx<=BUNKERX+BUNKERWIDTH && shoty>=BUNKERY && shoty<=BUNKERY+BUNKERHEIGHT) {
		// the shot is in the range - do a detailed bunker collision test
		adjy=shoty-BUNKERY;
		adjx=shotx-BUNKERX;
		if(bunker[adjy][adjx]==1)
			{
			bunker[adjy][adjx]=0;
			return 1;
			}
		}
	return 0;
}

void drawscore()
{
	int t,off;
	off=(SCREENWIDTH/2)-24;
	attrset(COLOR_PAIR(1));
	mvprintw(SCREENHEIGHT-1,off,"Level: %2.2d   Score: %7.7ld   Lives: ",level,score);
	for(t=0;((t<5)&&(t<lives));t++)
		mvprintw(SCREENHEIGHT-1,off+36+(4*t),"/-\\ ");
	for(;t<5;t++)
		mvprintw(SCREENHEIGHT-1,off+36+(4*t),"    ");
}

int main(int argc,char** argv)
{
	int i;
	int s, t;
	int ch, lastmove;
	int x, y, cx,cy;
	int movement, pos, shoot, shotx, shoty;
	int move_counter, shot_counter;
	int alienshot_counter, shootme_counter;

	int weite=0;

	score=0L;
	lives=3;
	lastmove=' ';
	skill_level=1;
	if (argc==3) {
		if (strcmp(argv[1],"-l")==0) {
			if (argv[2][0]>='0' && argv[2][0]<='9') {skill_level=argv[2][0]-48;} else {argc=2;}
		}
	}
	if (argc==2) {
		if (strcmp(argv[1],"-gpl")==0) {
			gpl();
		}
	}
	if (argc==2 || (argc==3 && strcmp(argv[1],"-l")!=0)) {
		fprintf(stderr,"*** nInvaders %i.%i.%i\n",MAJOR,MINOR,RELEASE);
		fprintf(stderr,"*** (C)opyleft 2k2 by Dettus\n");
		fprintf(stderr,"*** dettus@matrixx-bielefeld.de\n");
                fprintf(stderr,"Additional code by Mike Saarna\n");
		fprintf(stderr,"\n\nUsage: nInvaders [-l skill] [-gpl]\n");
		fprintf(stderr,"   where -l 0=NIGHTMARE\n");
		fprintf(stderr,"         -l 1=okay\n");
		fprintf(stderr,"         -l 9=May I play daddy?!\n");
		fprintf(stderr,"\n         -gpl shows you the license file\n");
		version();
		exit(1);	
	}
	init();
	initlevel();
	battlefield=newwin(SCREENHEIGHT-1,SCREENWIDTH,0,0);
	mvwin(battlefield,0,0);	
	attrset(COLOR_PAIR(3));
	timeout(0);
	for(level=1;;level++) {

		movement=1; pos=0; shoot=0; shotx=0; shoty=0; move_counter=0; 
		shot_counter=0; alienshot_counter=0; shootme_counter=0;
		x=0; y=0;
		weite=(shipnum+(skill_level*10)-(level*5)+5)/10;
		if(weite<0)
			weite=0;
		wclear(battlefield);
		copywin(bunkers,battlefield,0,0,BUNKERY,BUNKERX,BUNKERY+BUNKERHEIGHT-1,BUNKERX+BUNKERWIDTH-1,0);
		copywin(player,battlefield,0,0,SCREENHEIGHT-2,pos,SCREENHEIGHT-2,pos+4,0);
		drawscore(level,lives);
		for (;;) {
			if (move_counter==0) {
			/////// MOVE ALIENS AND TEST IF THEY'VE REACHED THE 
			/////// BOTTOM OF THE WINDOW OR THE BUNKERS.
				render();
				copywin(leer,battlefield,0,0,y,x,y+bottom,x+right+3,0);
				x=x+movement;
				if (x==(BUNKERWIDTH+BUNKERX-5-right) || x==(BUNKERX+left)) {
					y++;
					if (y==SCREENHEIGHT-2-bottom) {lives=0;game_over(1);}
					if (y==BUNKERY-bottom) {
						//CLEAR THE BUNKERS
						for(cx=0;cx<BUNKERWIDTH;cx++)
							for(cy=0;cy<BUNKERHEIGHT;cy++) 
								bunker[cy][cx]=0;
						copywin(clearbunkers,battlefield,0,0,BUNKERY,BUNKERX,BUNKERY+BUNKERHEIGHT-1,BUNKERX+BUNKERWIDTH-1,0);
					}
					movement=movement*(-1);
				}
				copywin(aliens,battlefield,0,0,y,x,y+bottom,x+right+3,0);

			}
			if (shoot==1 && shot_counter==0) 
			{
			/////// MOVE OUR SHOT AND DO ALIEN/BUNKER HIT TESTING
				copywin(leer,battlefield,0,0,shoty,shotx,shoty,shotx,0);
				shoty--;
				if (shoty<=0) {shoot=0;} else {
					copywin(shot,battlefield,0,0,shoty,shotx,shoty,shotx,0);
				}
				if (hit_player_test(shotx,shoty,x,y)==1) {
					score+=100;
					if(score%6000==0)
						lives++;
					drawscore(level,lives);
					copywin(leer,battlefield,0,0,y,x,y+bottom,x+right+3,0);
					shoot=0;render();
					if (shipnum==0) {
						break; //break to next level!
						//game_over(1);
					}
					//weite=shipnum/10+skill_level-level+1;
					weite=(shipnum+(skill_level*10)-(level*5)+5)/10;
					if(weite<0)
						weite=0;
					copywin(leer,battlefield,0,0,shoty,shotx,shoty,shotx,0);
					copywin(aliens,battlefield,0,0,y,x,y+bottom,x+right+3,0);
				}
				if (hit_bunker_test(shotx,shoty)==1) { //test if our shot hit the bunker
					copywin(leer,battlefield,0,0,shoty,shotx,shoty,shotx,0);
					shoty=0;
					shoot=0;
				}
			}
			if (alienshot_counter==0) {
			/////// MOVE ALIEN SHOTS AND DO PLAYER/BUNKER HIT TESTING
				for (i=0;i<50;i++) {
					if (alienshotx[i]!=0) {
						copywin(leer,battlefield,0,0,alienshoty[i],alienshotx[i],alienshoty[i],alienshotx[i],0);
						if (hit_bunker_test(alienshotx[i],alienshoty[i])==1) { //test if alien shot hit the bunker
							copywin(leer,battlefield,0,0,alienshoty[i],alienshotx[i],alienshoty[i],alienshotx[i],0);
							alienshotx[i]=0;
				}
						alienshoty[i]++;
						if (alienshoty[i]==SCREENHEIGHT-2) {
							if (alienshotx[i]>=pos && alienshotx[i]<=pos+4) {
								lives--;
								drawscore(level,lives);
								//explosion!
								for(t=0;t<5;t++)
									{
									wclear(player);
									for(s=0;s<5;s++)
										waddch(player,explosionchars[rand()%16]);
        								wrefresh(player);
									copywin(player,battlefield,0,0,SCREENHEIGHT-2,pos,SCREENHEIGHT-2,pos+4,0);
									wrefresh(battlefield);	
									usleep(100000);
									}
								if(lives==0)
									game_over(1);
								initplayer();
								copywin(player,battlefield,0,0,SCREENHEIGHT-2,pos,SCREENHEIGHT-2,pos+4,0);
								wrefresh(battlefield);	
							}
							alienshotx[i]=0;
						}
					} else {
						if (shootme_counter++>(skill_level*8+10)*(shipnum+5)) {
							shootme_counter=0;
							ch=random()%11;
							while (lowest_ship[ch]==-1) {
								ch=random()%11;	
							}
							alienshoty[i]=y+lowest_ship[ch];
							alienshotx[i]=x+ch*3;
						}

					}
				}
					
				for (i=0;i<50;i++) {
					if (alienshotx[i]!=0) {
						copywin(alienshot,battlefield,0,0,alienshoty[i],alienshotx[i],alienshoty[i],alienshotx[i],0);
					}
				}
			}
			if (alienshot_counter++>=5) {alienshot_counter=0;}
			if (shot_counter++>=1) {shot_counter=0;}
			if (move_counter++>=weite) {move_counter=0;}
			wrefresh(battlefield);	
			
			usleep(1);
			ch=getch();
			if ((ch=='l' || ch==KEY_RIGHT) && pos<SCREENWIDTH-5) {
				copywin(leer,battlefield,0,0,SCREENHEIGHT-2,pos,SCREENHEIGHT-2,pos+4,0);
				if((lastmove=='l') && (pos<SCREENWIDTH-6))
					pos=pos+1;
				pos=pos+1;
				lastmove='l';
				copywin(player,battlefield,0,0,SCREENHEIGHT-2,pos,SCREENHEIGHT-2,pos+4,0);
			}
			else if ((ch=='h' || ch==KEY_LEFT)  && pos>0)  {
				copywin(leer,battlefield,0,0,SCREENHEIGHT-2,pos,SCREENHEIGHT-2,pos+4,0);
				if((lastmove=='h') && (pos>1))
					pos=pos-1;
				pos=pos-1;
				lastmove='h';
				copywin(player,battlefield,0,0,SCREENHEIGHT-2,pos,SCREENHEIGHT-2,pos+4,0);
				mvwin(player,SCREENHEIGHT-2,pos);
			}
			else if ((ch=='k' || ch==' ') && shoot==0) {
				shoot=1;shotx=pos+2;shoty=SCREENHEIGHT-3;
			} 
			else if (ch=='p') {
				usleep(100000);
				while(getch()!='p')
					usleep(100000);
			} 
			else if (ch=='W') { break; } //WARP CHEAT FOR TESTING
			else
				lastmove=' ';
			if ((ch=='q' || ch==27)) {finish(0);}
		}
	initlevel();
	}

	return 0;	
	
}

static void finish(int sig)
{
        endwin();
fprintf(stderr,"
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Use the -gpl  command line switch to see the full license of this program
Use the -help command line switch to see who wrote this program 

");
	fprintf(stderr,"
=========================================================================

Final score: %7.7ld, Final level: %2.2d
Final rating... ",score,level);
	if (lives>0)
		fprintf(stderr,"Quitter\n\n");
	else if(score<5000)
		fprintf(stderr,"Alien Fodder\n\n");
	else if(score<7500)
		fprintf(stderr,"Easy Target\n\n");
	else if(score<10000)
		fprintf(stderr,"Barely Mediocre\n\n");
	else if(score<10000)
		fprintf(stderr,"Shows Promise\n\n");
	else if(score<15000)
		fprintf(stderr,"Alien Blaster\n\n");
	else if(score<20000)
		fprintf(stderr,"Earth Defender\n\n");
	else if(score>19999)
		fprintf(stderr,"Supreme Protector\n\n");
	version();
        exit(0);
}

